cqfd 12.8 KB
Newer Older
Mathieu Audat's avatar
Mathieu Audat committed
1 2 3 4
#!/bin/bash
#
# cqfd - a tool to wrap commands in controlled Docker containers
#
5
# Copyright (C) 2015-2018 Savoir-faire Linux, Inc.
Mathieu Audat's avatar
Mathieu Audat committed
6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set -e

PROGNAME=`basename $0`
23 24
VERSION=5.2.2-alpha
cqfddir=".cqfd"
Mathieu Audat's avatar
Mathieu Audat committed
25
cqfdrc=".cqfdrc"
26 27 28
cqfd_user='builder'
cqfd_user_home='/home/builder'
cqfd_user_cwd="$cqfd_user_home/src"
Mathieu Audat's avatar
Mathieu Audat committed
29 30 31

## usage() - print usage on stdout
usage() {
32
	cat <<EOF
Mathieu Audat's avatar
Mathieu Audat committed
33 34 35
Usage: $PROGNAME [OPTION ARGUMENT] [COMMAND] [ARGUMENTS]

Options:
36 37 38
    -f <file>           Use file as config file (default .cqfdrc).
    -d <directory>      Use directory as cqfd directory (default .cqfd).
    -C <directory>      Use the specified working directory.
Mathieu Audat's avatar
Mathieu Audat committed
39
    -b <flavor_name>    Target a specific build flavor.
40 41 42
    -q                  Turn on quiet mode
    -v or --version     Show version.
    -h or --help        Show this help text.
Mathieu Audat's avatar
Mathieu Audat committed
43 44 45

Commands:
    init     Initialize project build container
46
    flavors  List flavors from config file to stdout
Mathieu Audat's avatar
Mathieu Audat committed
47 48 49 50 51 52 53
    run      Run argument(s) inside build container
    release  Run argument(s) and release software
    help     Show this help text

    By default, run is assumed, and the run command is the one
    configured in .cqfdrc.

54
    cqfd is Copyright (C) 2015-2018 Savoir-faire Linux, Inc.
Mathieu Audat's avatar
Mathieu Audat committed
55 56 57 58 59 60 61

    This program comes with ABSOLUTELY NO WARRANTY. This is free
    software, and you are welcome to redistribute it under the terms
    of the GNU GPLv3 license; see the LICENSE for more informations.
EOF
}

62
# parse_ini_config_file()
Mathieu Audat's avatar
Mathieu Audat committed
63 64
#   Ref: http://theoldschooldevops.com/2008/02/09/bash-ini-parser/
# arg$1: path to ini file
65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98
parse_ini_config_file() {
	# bash 4.3 and later break compatibility
	local is_compatibility_mode=false
	if [ $BASH_VERSINFO -ge 4 -a ${BASH_VERSINFO[1]} -gt 2 ]; then
		is_compatibility_mode=true
		shopt -s compat42
	fi

	if ! ini="$(<$1)"; then           # read the file
		die "$1: No such file!"
	fi
	ini="${ini//[/\\[}"          # escape [
	ini="${ini//]/\\]}"          # escape ]
	IFS=$'\n' && ini=( ${ini} ) # convert to line-array
	ini=( ${ini[*]//;*/} )      # remove comments with ;
	ini=( ${ini[*]/\    =/=} )  # remove tabs before =
	ini=( ${ini[*]/=\   /=} )   # remove tabs be =
	ini=( ${ini[*]/\ =\ /=} )   # remove anything with a space around =
	ini=( ${ini[*]/#\\[/\}$'\n'cfg.section.} ) # set section prefix
	ini=( ${ini[*]/%\\]/ \(} )  # convert text2function (1)
	ini=( ${ini[*]/%\(/ \( \)} ) # close array parenthesis
	ini=( ${ini[*]/%\\ \)/ \\} ) # the multiline trick
	ini=( ${ini[*]/%\( \)/\(\) \{} ) # convert text2function (2)
	ini=( ${ini[*]/%\} \)/\}} ) # remove extra parenthesis
	ini[0]="" # remove first element
	ini[${#ini[*]} + 1]='}'    # add the last brace
	if ! eval "$(echo "${ini[*]}")" 2>/dev/null; then # eval the result
		die "$1: Invalid ini-file!"
	fi

	# restore previous bash behaviour
	if $is_compatibility_mode; then
		shopt -u compat42
	fi
Mathieu Audat's avatar
Mathieu Audat committed
99 100 101 102 103
}

## die() - exit when an error occured
# $@ messages and variables shown in the error message
die() {
104 105
	echo "cqfd: fatal: $@" 1>&2
	exit 1
Mathieu Audat's avatar
Mathieu Audat committed
106 107 108 109
}

# docker_build() - Initialize build container
docker_build() {
110 111 112 113 114 115 116 117 118 119
	local dockerfile="${cqfddir}/${distro:-docker}/Dockerfile"

	if [ ! -f $dockerfile ]; then
		die "no Dockerfile found at location $dockerfile"
	fi
	if [ -z "$project_build_context" ]; then
		docker build ${quiet:+-q} $CQFD_EXTRA_BUILD_ARGS -t "$docker_img_name" "$(dirname "$dockerfile")"
	else
		docker build ${quiet:+-q} $CQFD_EXTRA_BUILD_ARGS -t "$docker_img_name" "${project_build_context}" -f "$dockerfile"
	fi
Mathieu Audat's avatar
Mathieu Audat committed
120 121 122 123 124 125
}

# docker_run() - run command in configured container
# A few implementation details:
#
# - The user executing the build commands inside the container is
126
#   named after $cqfd_user, with the same uid/gid as your user to keep
Mathieu Audat's avatar
Mathieu Audat committed
127 128
#   filesystem permissions in sync.
#
129
# - Your project's source directory is always mapped to $cqfd_user_cwd
Mathieu Audat's avatar
Mathieu Audat committed
130
#
131 132 133
# - Your ~/.ssh directory is mapped to ~${cqfd_user}/.ssh to provide
#   access to the ssh keys (your build may pull authenticated git
#   repos for example).
Mathieu Audat's avatar
Mathieu Audat committed
134
#
135
# arg$1: the command string to execute as $cqfd_user
Mathieu Audat's avatar
Mathieu Audat committed
136 137
#
docker_run() {
138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212
	local interactive_options

	if tty -s; then
		interactive_options="-ti"
	fi

	# If possible, map cqfd_user from the calling user's
	if [ -n "$USER" ]; then
		cqfd_user="$USER"
	fi

	if [ -n "$HOME" ]; then
		cqfd_user_home="$(cd $HOME; pwd)"
		cqfd_user_cwd="$(pwd)"
	fi

	# Display a warning message if using no more supported options
	if [ -n "$CQFD_EXTRA_VOLUMES" ]; then
		die 'Warning: CQFD_EXTRA_VOLUMES is no more supported, use
		CQFD_EXTRA_RUN_ARGS="-v <local_dir>:<container_dir>"'
	fi
	if [ -n "$CQFD_EXTRA_HOSTS" ]; then
		die 'Warning: CQFD_EXTRA_HOSTS is no more supported, use
		CQFD_EXTRA_RUN_ARGS="--add-host <hostname>:<IP_address>"'
	fi
	if [ -n "$CQFD_EXTRA_ENV" ]; then
		die 'Warning: CQFD_EXTRA_ENV is no more supported, use
		CQFD_EXTRA_RUN_ARGS="-e <var_name>=<value>"'
	fi
	if [ -n "$CQFD_EXTRA_PORTS" ]; then
		die 'Warning: CQFD_EXTRA_PORTS is no more supported, use
		CQFD_EXTRA_RUN_ARGS="-p <host_port>:<docker_port>"'
	fi

	# The user may set the user_extra_groups in the .cqfdrc
	# file to add groups to the user in the container.
	local group
	if [ -n "$cqfd_extra_groups" ]; then
		for group in $cqfd_extra_groups; do
			# optional groupd id specified ("name:123")
			if echo "$group" | grep -qE ":[0-9]+$"; then
				CQFD_GROUPS+="${group} "
			else
				id=$(awk -F: "\$1 == \"$group\" { print \$3 }" /etc/group)
				CQFD_GROUPS+="${group}:${id} "
			fi
		done
	fi

	# The user may set the CQFD_EXTRA_RUN_ARGS environment variables
	# to pass custom run arguments to his development container.

	# Set HOME variable for the $cqfd_user, except if it was
	# explicitely set via CQFD_EXTRA_RUN_ARGS
	local home_env_var="HOME=$cqfd_user_home"
	if echo "$CQFD_EXTRA_RUN_ARGS" | egrep -q "(-e[[:blank:]]*|--env[[:blank:]]+)HOME="; then
		home_env_var=""
	fi

	tmp_launcher=$(make_launcher)

	trap "rm -f $tmp_launcher" EXIT

	docker run --privileged \
	       $CQFD_EXTRA_RUN_ARGS \
	       --rm \
	       --log-driver=none \
	       -v "$tmp_launcher":/bin/cqfd_launch \
	       -v ~/.ssh:"$cqfd_user_home"/.ssh \
	       -v "$PWD":"$cqfd_user_cwd" \
	       ${home_env_var:+ -e "$home_env_var"} \
	       $interactive_options \
	       ${SSH_AUTH_SOCK:+ -v $SSH_AUTH_SOCK:"$cqfd_user_home"/.sockets/ssh} \
	       ${SSH_AUTH_SOCK:+ -e SSH_AUTH_SOCK="$cqfd_user_home"/.sockets/ssh} \
	       $docker_img_name cqfd_launch "$@" 2>&1
Mathieu Audat's avatar
Mathieu Audat committed
213 214 215 216 217 218 219 220
}

# make_archive(): Create a release package.
# Note: the --transform option passed to tar allows to move all the
# specified files at the root of the archive. Therefore, you shouldn't
# include two files with the same name in the list of files to
# archive.
make_archive() {
221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349
	local tar_opts

	if [ -z "$release_files" ]; then
		die "No files to archive, check files in $cqfdrc"
	fi

	for file in $release_files; do
		if [ ! -e $file ]; then
			die "Cannot release: can't find $file"
		fi
	done

	# template the generated archive's filename
	local git_short=`git rev-parse --short HEAD 2>/dev/null`
	local git_long=`git rev-parse HEAD 2>/dev/null`
	local date_rfc3339=`date +"%Y-%m-%d"`

	# default name for the archive if not set
	if [ -z "$release_archive" ]; then
		release_archive="%Po-%Pn.tar.xz"
	fi

	release_archive=`echo $release_archive |
		sed -e 's!%%!%!g;
			s!%Gh!'$git_short'!g;
			s!%GH!'$git_long'!g;
			s!%D3!'$date_rfc3339'!g;
			s!%Po!'$project_org'!g;
			s!%Pn!'$project_name'!g;
			s!%Cf!'$flavor'!g;'`

	# also replace variable names - beware with eval
	eval release_archive=`echo $release_archive`

	# setting tar_transform=yes will move files to the root of a tar archive
	if [ "$release_transform" = "yes" ]; then
		tar_opts='--transform s/.*\///g'
	fi

	# setting tar_options will add the following options to the tar
	# command
	if [ -n "$tar_options" ]; then
		tar_opts="$tar_opts $tar_options"
	fi

	# support the following archive formats
	case "$release_archive" in
	*.tar.xz)
		XZ_OPT=-9 tar $tar_opts -cJf \
			"$release_archive" $release_files
		;;
	*.tar.gz)
		tar $tar_opts -czf \
			"$release_archive" $release_files
		;;
	*.zip)
		zip -q -9 -r "$release_archive" $release_files
		;;
	*)
		;;
	esac
}

# make_launcher - generate in-container launcher script
# return: the path to the launcher script on stdout
make_launcher()
{
	local tmpfile=$(mktemp /tmp/tmp.XXXXXX)

	chmod 0755 $tmpfile
	cat >$tmpfile <<EOF
#!/bin/sh
# create container user to match expected environment

die () {
	echo "error: \$*"
	exit 1
}

test_cmd () {
	command -v "\$1" > /dev/null 2>&1
}

debug () {
      test -n "\$CQFD_DEBUG" && echo "debug: \$*"
}

# Check container requirements
test -x /bin/bash || { failed=1 && echo "error: /bin/bash does not exist or is not executable"; }
test_cmd groupadd || { failed=1 && echo "error: Missing command: groupadd"; }
test_cmd useradd || { failed=1 && echo "error: Missing command: useradd"; }
test_cmd usermod || { failed=1 && echo "error: Missing command: usermod"; }
test_cmd chown || { failed=1 && echo "error: Missing command: chown"; }
test_cmd sudo && has_sudo=1 || test_cmd su ||
	{ failed=1 && echo "error: Missing command: su or sudo"; }
test -n "\$failed" &&
	die "Some dependencies are missing from the container, see above messages."

# Add the host's user and group to the container, and adjust ownership.
groupadd -og $GROUPS -f builders || die "groupadd command failed."
useradd -s /bin/bash -ou $UID -g $GROUPS -d "$cqfd_user_home" $cqfd_user \
	|| die "useradd command failed."
chown $UID:$GROUPS "$cqfd_user_home" || die "chown command failed."

# Add specified groups to cqfd_user
for g in ${CQFD_GROUPS}; do
	group=\$(echo "\$g" | cut -d: -f1)
	gid=\$(echo "\$g" | cut -d: -f2)

	if [ -n "\$gid" ]; then
		# create group with provided id ("name:123")
		groupadd -og "\$gid" -f "\$group" || die "groupadd failed for \$group."
	fi

	usermod -a -G \$group $cqfd_user || die "usermod command failed while adding group \${group}."
done

# run the provided command in the working directory
cd "$cqfd_user_cwd" || die "Changing directory to \"$cqfd_user_cwd\" failed."
if [ -n "\$has_sudo" ]; then
	# Use sudo to provide a controlling TTY for the executed command
	debug "Using \"sudo\" to execute command \"\$@\" as user \"$cqfd_user\""
	sudo -E -u $cqfd_user sh -c "\$@"
else
	debug "Using \"su\" to execute command \"\$@\" as user \"$cqfd_user\""
	su $cqfd_user -p -c "\$@"
fi
EOF
	echo $tmpfile
Mathieu Audat's avatar
Mathieu Audat committed
350 351 352 353 354
}

# config_load() - load build settings from cqfdrc
# $1: optional "flavor" of the build, is a suffix of command.
config_load() {
355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392
	IFS="$IFS" parse_ini_config_file "$cqfdrc"

	cfg.section.project # load the [project] section
	project_org="$org"
	project_name="$name"
	project_build_context="$build_context"

	cfg.section.build # load the [build] section

	# build parameters may be overriden by a flavor defined in the
	# build section's 'flavors' parameter.
	local flavor="$1"
	if [ -n "$flavor" ]; then
		if grep -qw "$flavor" <<< "$flavors"; then
			cfg.section."$flavor" # load the [$flavor] section
		else
			die "flavor \"$flavor\" not found in flavors list"
		fi
	fi

	build_cmd="$command"
	cqfd_extra_groups="$user_extra_groups"
	release_files="`eval echo $files`"
	release_archive="$archive"
	release_transform="$tar_transform"
	tar_options="$tar_options"

	# This will look like fooinc_reponame
	if [ -n "$project_org" -a -n "$project_name" ]; then
		docker_img_name="cqfd${USER:+_${USER}}_${project_org}_${project_name}"
	else
		die "project.org and project.name not configured"
	fi

	# Adapt things for a specific container
	if [ -n "$distro" ]; then
		docker_img_name+="_$distro"
	fi
Mathieu Audat's avatar
Mathieu Audat committed
393 394
}

395
has_to_release=false
Mathieu Audat's avatar
Mathieu Audat committed
396
while [ $# -gt 0 ]; do
397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454
	case "$1" in
	help|-h|"--help")
		usage
		exit 0
		;;
	version|-v|"--version")
		echo $VERSION
		exit 0
		;;
	init)
		config_load $flavor
		docker_build
		exit $?
		;;
	flavors)
		config_load
		echo $flavors
		exit 0
		;;
	-b)
		shift
		flavor="$1"
		;;
	-d)
		shift
		cqfddir="$1"
		;;
	-f)
		shift
		cqfdrc="$1"
		;;
	-C)
		shift
		cd "$1"
		;;
	-q)
		quiet=true
		;;
	run|release)
		if [ "$1" = "release" ]; then
			has_to_release=true
		fi
		if [ $# -gt 1 ]; then
			shift
			build_cmd_alt="$@"
		fi
		break
		;;
	?*)
		echo "Unknown command: $1"
		usage
		exit 1
		;;
	*)
		# empty or no argument case
		;;
	esac
	shift
Mathieu Audat's avatar
Mathieu Audat committed
455 456 457 458 459
done

config_load $flavor

if [ -n "$build_cmd_alt" ]; then
460
	build_cmd=$build_cmd_alt
Mathieu Audat's avatar
Mathieu Audat committed
461
elif [ -z "$build_cmd" ]; then
462
	die "No build.command defined in $cqfdrc !"
Mathieu Audat's avatar
Mathieu Audat committed
463 464 465 466
fi

docker_run "$build_cmd"

467 468
if $has_to_release; then
	make_archive
Mathieu Audat's avatar
Mathieu Audat committed
469
fi